VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   1935
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   3720
   LinkTopic       =   "Form1"
   ScaleHeight     =   1935
   ScaleWidth      =   3720
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame Frame1 
      Caption         =   "Byte"
      Height          =   975
      Index           =   1
      Left            =   1920
      TabIndex        =   8
      Top             =   840
      Width           =   1695
      Begin VB.Label Label1 
         Caption         =   "ByVal"
         Height          =   255
         Index           =   4
         Left            =   240
         TabIndex        =   12
         Top             =   600
         Width           =   495
      End
      Begin VB.Label lblByteByVal 
         Height          =   255
         Left            =   840
         TabIndex        =   11
         Top             =   600
         Width           =   735
      End
      Begin VB.Label Label1 
         Caption         =   "ByRef"
         Height          =   255
         Index           =   3
         Left            =   240
         TabIndex        =   10
         Top             =   240
         Width           =   495
      End
      Begin VB.Label lblByteByRef 
         Height          =   255
         Left            =   840
         TabIndex        =   9
         Top             =   240
         Width           =   735
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "Integer"
      Height          =   975
      Index           =   0
      Left            =   120
      TabIndex        =   3
      Top             =   840
      Width           =   1695
      Begin VB.Label lblIntegerByRef 
         Height          =   255
         Left            =   840
         TabIndex        =   7
         Top             =   240
         Width           =   735
      End
      Begin VB.Label Label1 
         Caption         =   "ByRef"
         Height          =   255
         Index           =   1
         Left            =   240
         TabIndex        =   6
         Top             =   240
         Width           =   495
      End
      Begin VB.Label lblIntegerByVal 
         Height          =   255
         Left            =   840
         TabIndex        =   5
         Top             =   600
         Width           =   735
      End
      Begin VB.Label Label1 
         Caption         =   "ByVal"
         Height          =   255
         Index           =   2
         Left            =   240
         TabIndex        =   4
         Top             =   600
         Width           =   495
      End
   End
   Begin VB.TextBox txtIterations 
      Height          =   285
      Left            =   1080
      TabIndex        =   0
      Text            =   "1000000"
      Top             =   120
      Width           =   975
   End
   Begin VB.CommandButton cmdGo 
      Caption         =   "Go"
      Default         =   -1  'True
      Height          =   375
      Left            =   2640
      TabIndex        =   2
      Top             =   240
      Width           =   495
   End
   Begin VB.TextBox txtAssignments 
      Height          =   285
      Left            =   1080
      TabIndex        =   1
      Text            =   "1"
      Top             =   480
      Width           =   975
   End
   Begin VB.Label Label1 
      Caption         =   "Iterations"
      Height          =   255
      Index           =   0
      Left            =   120
      TabIndex        =   14
      Top             =   120
      Width           =   735
   End
   Begin VB.Label Label1 
      Caption         =   "Assignments"
      Height          =   255
      Index           =   5
      Left            =   120
      TabIndex        =   13
      Top             =   480
      Width           =   975
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private m_NumAssignments As Long
Private Sub ByteByRef(ByRef X As Byte)
Dim i As Long

    For i = 1 To m_NumAssignments
        X = 123
    Next i
End Sub


Private Sub IntegerByRef(ByRef X As Integer)
Dim i As Long

    For i = 1 To m_NumAssignments
        X = 123
    Next i
End Sub

Private Sub ByteByVal(ByVal X As Byte)
Dim i As Long

    For i = 1 To m_NumAssignments
        X = 123
    Next i
End Sub

Private Sub IntegerByVal(ByVal X As Integer)
Dim i As Long

    For i = 1 To m_NumAssignments
        X = 123
    Next i
End Sub
Private Sub cmdGo_Click()
Dim num_trials As Long
Dim start_time As Single
Dim stop_time As Single
Dim i As Long
Dim value_integer As Integer
Dim value_byte As Byte

    lblIntegerByRef.Caption = ""
    lblIntegerByVal.Caption = ""
    lblByteByRef.Caption = ""
    lblByteByVal.Caption = ""
    Screen.MousePointer = vbHourglass
    DoEvents

    ' Integers.
    num_trials = CLng(txtIterations.Text)
    m_NumAssignments = CLng(txtAssignments.Text)
    start_time = Timer
    For i = 1 To num_trials
        IntegerByRef value_integer
    Next i
    stop_time = Timer
    lblIntegerByRef.Caption = Format$(stop_time - start_time, "0.00")
    DoEvents

    start_time = Timer
    For i = 1 To num_trials
        IntegerByVal value_integer
    Next i
    stop_time = Timer
    lblIntegerByVal.Caption = Format$(stop_time - start_time, "0.00")
    DoEvents

    ' Bytes.
    start_time = Timer
    For i = 1 To num_trials
        ByteByRef value_byte
    Next i
    stop_time = Timer
    lblByteByRef.Caption = Format$(stop_time - start_time, "0.00")
    DoEvents

    start_time = Timer
    For i = 1 To num_trials
        ByteByVal value_byte
    Next i
    stop_time = Timer
    lblByteByVal.Caption = Format$(stop_time - start_time, "0.00")
    DoEvents

    Screen.MousePointer = vbDefault
End Sub

